"use strict";

// Теоретический вопрос

// Опишите своими словами как работает цикл forEach.
// ОТВЕТ: оператор forEach всегда выполняет функцию callback по одному разу для
// каждого єлемента из массива и возвращает только значение undefined.
// Когда оператор входит в цикл, то присваевает значение перменной undefined первому
// элементу массива и при каждой слетующей итерации выбирает каждый следующий
// элемент и массива, сохраняя перменную undefined.

// Задание

// Реализовать функцию фильтра массива по указанному типу данных. Задача должна
// быть реализована на языке javascript, без использования фреймворков
// и сторонник библиотек (типа Jquery).

// Технические требования:
// Написать функцию filterBy(), которая будет принимать в себя 2 аргумента.
// Первый аргумент - массив, который будет содержать в себе любые данные,
// второй аргумент - тип данных.
// Функция должна вернуть новый массив, который будет содержать в себе все данные,
// которые были переданы в аргумент, за исключением тех, тип которых был передан
// вторым аргументом.
// То есть, если передать массив ['hello', 'world', 23, '23', null], и
// вторым аргументом передать 'string', то функция вернет массив [23, null].

function filterBy(arr, item) {
  let newArr = arr.filter((el) => typeof el !== item);
  return console.log(newArr);
}
filterBy(["hello", "world", 23, "23", null], "string");
